#!/usr/bin/env pypy3
import collections, argparse

parser = argparse.ArgumentParser()
parser.add_argument("--group")
args = parser.parse_args()

n, m = map(int, input().split())
assert n <= 500_000
assert m <= 500_000
if args.group == "N=1e3":
    assert n <= 1000
    assert m <= 10_000

graph = [None] + [set() for _ in range(n)]
for _ in range(m):
    u, v = map(int, input().split())
    assert 1 <= u <= n
    assert 1 <= v <= n
    assert v not in graph[u], "duplicate edge"
    assert u not in graph[v], "duplicate edge"
    graph[u].add(v)
    graph[v].add(u)

seen = {1}
queue = collections.deque([1])
while len(queue) != 0:
    node = queue.popleft()
    for x in graph[node]:
        if x not in seen:
            queue.append(x)
            seen.add(x)
assert len(seen) == n, "graph is not connected"
