#include <iostream>
#include <fstream>
#include <cstdlib>
#include <vector>
#include <set>
using namespace std;

#define done(r, m) (cout << r << '\n', cerr << m << '\n', exit(0))

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: " << argv[0] << " input hint output");
	}

	ifstream in(argv[1]);
	//ifstream hint(argv[2]);
	ifstream out(argv[3]);

	int n, m;
	in >> n >> m;

	vector<int> a;
	set<int> s;
	for (int x; out >> x; ) {
		if (1 > x or x > n) done(0, "Invalid value in output");
		if (s.count(x) > 0) done(0, "Duplicate value in output");
		s.insert(x);
		a.push_back(x);
	}
	out.clear();
	char c;
	if (out >> c) done(0, "Invalid data in output");
	if (a.size() != n) done(0, "Invalid length of output");

	for (int i = 0; i < m; ++i) {
		int k;
		in >> k;
		vector<int> b(k);
		for (auto & x : b) in >> x;
		int j = 0;
		for (auto x : a) if (j < k and b[j] == x) ++j;
		if (j < k) done(0, "Input " << (1 + i) << " not a subsequence of output");
	}
	done(1, "OK");
}
