#!/usr/bin/env python3

# Input validator

import sys

st = {2, 3, 4}

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')
fh = open(sys.argv[3], 'rt')

# 1 - sequential, 2 - non-sequential, 3 - not a subsequence
def issub(a, b):
	j = 1
	i1, i2 = -1, -1
	for i in range(len(a)):
		if j < len(b) and a[i] == b[j]:
			if i1 < 0: i1 = i
			i2 = i
			j += 1
	if j < len(b): return 3
	if i2 - i1 > len(b) - 2: return 2
	return 1

n, m = (int(x) for x in fi.readline().split())
if 1 > n or n > 1e5:
	sys.exit('N out of range')
if 1 > m or m > 1e5:
	sys.exit('M out of range')
print(n, m, file=fo)

a = [int(x) for x in fh.readline().split()]
if sorted(a) != list(range(1, 1 + n)):
	sys.exit('A not a permutation of 1..N')

sk = 0
for i in range(m):
	b = [int(x) for x in fi.readline().split()]
	if 2 > b[0] or b[0] > n:
		sys.exit(f'K[{2 + i}] out of range')
	sk += b[0]
	t = issub(a, b)
	if t == 3:
		sys.exit(f'B[{2 + i}] not a subsequence')
	if t == 2:
		st.discard(2)
	print(*b, file=fo)
if n > 1000 or sk > 1000:
	st.discard(3)

fi.close()
fo.close()

if len(sys.argv) > 4 and sys.argv[4] == '-v':
	print('subtasks:', *st)
