#!/usr/bin/env python3

import argparse

parser = argparse.ArgumentParser()
parser.add_argument("--group")

args = parser.parse_args()

import subprocess
from tempfile import NamedTemporaryFile
from sys import stdin, exit

with NamedTemporaryFile("w+") as f, NamedTemporaryFile("w") as f2:
    while True:
        data = stdin.read()
        if len(data) == 0:
            break
        f.write(data)
    f.flush()
    res = subprocess.run(["gen/icheck.py", f.name, f2.name, "", "-v"], capture_output=True)
    if res.returncode != 0:
        exit(res.returncode)
    st = res.stdout.decode().split()[1:]
    if args.group is not None and args.group not in st:
        exit(f"Bad group")
