#include <cstdint>
#include "testlib.h"

using namespace std;

const int MAX_A = 1'000'000'000;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  int n = opt<int>("n");
  int m = opt<int>("m");
  int p = opt<int>("p");
  int q = opt<int>("q");
  int md = opt<int>("md"); // maximum difference between adjacent steps

  vector<int> arr (n + 1);

  int mn = 0;
  arr[0] = 0;
  for (int i = 1; i <= n; i++) {
    arr[i] = arr[i - 1] + rnd.next(-md, md);
    arr[i] = min(arr[i], MAX_A);
    
    mn = min(mn, arr[i]);
  }

  for (int i = 0; i <= n; i++) {
    arr[i] -= mn;
    arr[i] = min(arr[i], MAX_A);
  }

  cout << n << " " << m << " " << p << " " << q << '\n';
  for (int i = 0; i <= n; i++) {
    cout << arr[i];
    if (i != n)
      cout << " ";
  }
  cout << '\n';
}
