// naive solution, O(n^4) time
// go through all intervals in increasing order and check which kind these can be
// then use DP to construct the final solution that optimizes whatever
// this creates int overflow and must get wrong answer on some test cases

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef int ll;

const int FLAT = 0;
const int RISE = 1;
const int FALL = 2;

const string names [3] = {"TASANE", "TOUSEV", "LASKUV"};

const int INF = 1e9 + 5;

struct Phase {
  int start, end, type;
};

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);

  int n, m, p, q;
  cin >> n >> m >> p >> q;

  vector<int> arr (n + 1);
  for (int i = 0; i <= n; i++)
    cin >> arr[i];

  vector<vector<int>> ok (n + 1, vector<int> (n + 1, 0)); // ok[l][r] - bitmask of valid kinds
  for (int k = 1; k <= n; k++) {
    for (int l = 0; l + k <= n; l++) {
      int r = l + k;

      // try flat
      if ((ll) abs(arr[r] - arr[l]) * q < p) {
        ok[l][r] |= 1 << FLAT;
      }

      // rise
      if (r - l >= m && (ll) (arr[r] - arr[l]) * q >= (ll) p * (r - l)) {
        ok[l][r] |= 1 << RISE;
      }

      // fall
      if (r - l >= m && (ll) (arr[l] - arr[r]) * q >= (ll) p * (r - l)) {
        ok[l][r] |= 1 << FALL;
      }

      for (int L = l; L <= r; L++) {
        for (int R = l + 1; R <= r; R++) {
          if (ok[L][R] & 1 << RISE)
            ok[l][r] &= 1 << RISE;
          if (ok[L][R] & 1 << FALL)
            ok[l][r] &= 1 << FALL;
        }
      }
    }
  }
  
  vector<vector<int>> dp (n + 1, vector<int> (3, INF));
  vector<vector<pair<int, int>>> last (n + 1, vector<pair<int, int>> (3));

  for (int k = 0; k < 3; k++)
    dp[0][k] = 0;

  for (int i = 0; i < n; i++) {
    for (int k = 0; k < 3; k++) {
      if (dp[i][k] == INF)
        continue;

      for (int j = i + 1; j <= n; j++) {
        for (int l = 0; l < 3; l++) {
          if (k == l)
            continue;

          if (!(ok[i][j] & 1 << l))
            continue;

          if (dp[j][l] > 1 + dp[i][k]) {
            dp[j][l] = 1 + dp[i][k];
            last[j][l] = make_pair(i, k);
          }
        }
      }
    }
  }

  pair<int, int> cur = make_pair(n, 0);
  for (int k = 0; k < 3; k++) {
    if (dp[n][k] < dp[cur.first][cur.second]) {
      cur = make_pair(n, k);
    }
  }

  if (dp[cur.first][cur.second] == INF) {
    cout << -1 << '\n';
    return 0;
  }

  cout << dp[cur.first][cur.second] << '\n';

#ifndef SKIP_CONSTRUCTION
  vector<Phase> ans;
  
  while (cur.first != 0) {
    auto nxt = last[cur.first][cur.second];
    ans.push_back(Phase {.start = nxt.first, .end = cur.first, .type = cur.second});
    cur = nxt;
  }

  reverse(ans.begin(), ans.end());

  for (auto phase : ans) {
    cout << phase.start << " " << phase.end << " " << names[phase.type] << '\n';
  }
#endif
}
