import sys

INF = 10**9

FLAT = 0
RISE = 1
FALL = 2
names = ["TASANE", "TOUSEV", "LASKUV"]

n, m, p, q = map(int, input().split())
arr = list(map(int, input().split()))

last_fall = -1
last_rise = -1
dp = [[(INF, -1, -1) for k in range(3)] for i in range(n + 1)]
for k in range(3):
    dp[0][k] = (0, -1, -1)

for i in range(1, n + 1):
    for j in range(i - 1, -1, -1):
        # rise
        if q * (arr[i] - arr[j]) >= p * (i - j) and i - j >= m and j > last_fall:
            last_rise = max(last_rise, j)
            for k in range(3):
                if k == RISE:
                    continue

                dp[i][RISE] = min(dp[i][RISE], (dp[j][k][0] + 1, j, k))

        # fall
        if q * (arr[i] - arr[j]) <= -p * (i - j) and i - j >= m and j > last_rise:
            last_fall = max(last_fall, j)
            for k in range(3):
                if k == FALL:
                    continue

                dp[i][FALL] = min(dp[i][FALL], (dp[j][k][0] + 1, j, k))


        # flat
        if -p < q * (arr[i] - arr[j]) and q * (arr[i] - arr[j]) < p and j > last_rise and j > last_fall:
            for k in range(3):
                if k == FLAT:
                    continue

                dp[i][FLAT] = min(dp[i][FLAT], (dp[j][k][0] + 1, j, k))

best = (INF, -1, -1)
for k in range(3):
    best = min(best, (dp[n][k][0], n, k))

if best[0] == INF:
    print(-1)
    sys.exit(0)

ans = []
cur_i = best[1]
cur_k = best[2]

while cur_i > 0:
    nxt = dp[cur_i][cur_k]
    ans.append((nxt[1], cur_i, cur_k))
    cur_i = nxt[1]
    cur_k = nxt[2]

print(len(ans))
for p in reversed(ans):
    print(p[0], p[1], names[p[2]])
