// greedy + brute force
// calculates the ok matrix the same way as the naive solution, but doesn't use dp
// instead, it backtracks, stopping when a finished solution is found

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const int FLAT = 0;
const int RISE = 1;
const int FALL = 2;

const string names [3] = {"TASANE", "TOUSEV", "LASKUV"};

const int INF = 1e9 + 5;

struct Phase {
  int start, end, type;
};

void rec (int pos, int last, const vector<vector<int>> &ok, vector<Phase> &cur, int n) {
  if (pos == n) {
    cout << cur.size() << '\n';
    for (auto phase : cur) {
      cout << phase.start << " " << phase.end << " " << names[phase.type] << '\n';
    }

    exit(0);
  }

  vector<pair<int, int>> candidates;
  for (int r = pos + 1; r <= n; r++) {
    for (int k = 0; k < 3; k++) {
      if (k == last)
        continue;

      if (ok[pos][r] & 1 << k)
        candidates.emplace_back(r, k);
    }
  }

  sort(candidates.begin(), candidates.end(), greater<pair<int, int>>());

  for (auto c : candidates) {
    cur.push_back(Phase {.start = pos, .end = c.first, .type = c.second });
    rec(c.first, c.second, ok, cur, n);
    cur.pop_back();
  }
}

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);

  int n, m, p, q;
  cin >> n >> m >> p >> q;

  vector<int> arr (n + 1);
  for (int i = 0; i <= n; i++)
    cin >> arr[i];

  vector<vector<int>> ok (n + 1, vector<int> (n + 1, 0)); // ok[l][r] - bitmask of valid kinds
  for (int k = 1; k <= n; k++) {
    for (int l = 0; l + k <= n; l++) {
      int r = l + k;

      // try flat
      if ((ll) abs(arr[r] - arr[l]) * q < p) {
        ok[l][r] |= 1 << FLAT;
      }

      // rise
      if (r - l >= m && (ll) (arr[r] - arr[l]) * q >= (ll) p * (r - l)) {
        ok[l][r] |= 1 << RISE;
      }

      // fall
      if (r - l >= m && (ll) (arr[l] - arr[r]) * q >= (ll) p * (r - l)) {
        ok[l][r] |= 1 << FALL;
      }

      for (int L = l; L <= r; L++) {
        for (int R = l + 1; R <= r; R++) {
          if (ok[L][R] & 1 << RISE)
            ok[l][r] &= 1 << RISE;
          if (ok[L][R] & 1 << FALL)
            ok[l][r] &= 1 << FALL;
        }
      }
    }
  }

  vector<Phase> cur;
  rec(0, -1, ok, cur, n);

  cout << -1 << '\n';
}
